> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/software-delivery-agent-apis/gitops/argo-projects.md).

# Argo Projects

## GET /api/v2/agents/{agentIdentifier}/argoprojects

> ListForAgent lists all ArgoCD AppProjects mapped to this agent.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v2/agents/{agentIdentifier}/argoprojects":{"get":{"description":"ListForAgent lists all ArgoCD AppProjects mapped to this agent.","operationId":"AgentArgoProjectService_ListForAgent","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1ArgoProjectList"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"query.name","in":"query","required":false,"schema":{"type":"string"}},{"name":"pageSize","in":"query","required":false,"schema":{"type":"integer","format":"int32"}},{"name":"pageIndex","in":"query","required":false,"schema":{"type":"integer","format":"int32"}}],"tags":["ArgoProjects"]}}},"components":{"schemas":{"v1ArgoProjectList":{"type":"object","properties":{"content":{"type":"array","items":{"$ref":"#/components/schemas/v1ArgoProject"}},"totalPages":{"type":"integer","format":"int32"},"totalItems":{"type":"integer","format":"int32"},"pageItemCount":{"type":"integer","format":"int32"},"pageSize":{"type":"integer","format":"int32"},"pageIndex":{"type":"integer","format":"int32"},"empty":{"type":"boolean"}}},"v1ArgoProject":{"type":"object","properties":{"id":{"type":"string"},"accountIdentifier":{"type":"string","description":"Account Identifier for the ArgoProject."},"projectIdentifier":{"type":"string","description":"Project Identifier for the ArgoProject. (Depends on mapping)"},"orgIdentifier":{"type":"string","description":"Organization Identifier for the ArgoProject. (Depends on mapping)"},"name":{"type":"string"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"agentIdentifier":{"type":"string","description":"Agent identifier for ArgoProject. This will be prefixed with scope."},"appProject":{"$ref":"#/components/schemas/appprojectsAppProject"}},"description":"AppProject resource with harness metadata and additional fields."},"appprojectsAppProject":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/appprojectsAppProjectSpec"},"status":{"$ref":"#/components/schemas/appprojectsAppProjectStatus"}},"title":"AppProject provides a logical grouping of applications, providing controls for:\n* where the apps may deploy to (cluster whitelist)\n* what may be deployed (repository whitelist, resource whitelist/blacklist)\n* who can access these applications (roles, OIDC group claims bindings)\n* and what they can do (RBAC policies)\n* automation access to these roles (JWT tokens)\n+genclient\n+genclient:noStatus\n+k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object\n+kubebuilder:resource:path=appprojects,shortName=appproj;appprojs"},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"appprojectsAppProjectSpec":{"type":"object","properties":{"sourceRepos":{"type":"array","items":{"type":"string"},"title":"SourceRepos contains list of repository URLs which can be used for deployment"},"destinations":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestination"},"title":"Destinations contains list of destinations available for deployment"},"description":{"type":"string","title":"Description contains optional project description"},"roles":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsProjectRole"},"title":"Roles are user defined RBAC roles associated with this project"},"clusterResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceWhitelist contains list of whitelisted cluster level resources"},"namespaceResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceBlacklist contains list of blacklisted namespace level resources"},"orphanedResources":{"$ref":"#/components/schemas/appprojectsOrphanedResourcesMonitorSettings"},"syncWindows":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSyncWindow"},"title":"SyncWindows controls when syncs can be run for apps in this project"},"namespaceResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceWhitelist contains list of whitelisted namespace level resources"},"signatureKeys":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSignatureKey"},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKeys contains a list of PGP key IDs that commits in Git must be signed with in order to be allowed for sync"},"clusterResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceBlacklist contains list of blacklisted cluster level resources"},"sourceNamespaces":{"type":"array","items":{"type":"string"},"title":"SourceNamespaces defines the namespaces application resources are allowed to be created in"},"permitOnlyProjectScopedClusters":{"type":"boolean","title":"PermitOnlyProjectScopedClusters determines whether destinations can only reference clusters which are project-scoped"},"destinationServiceAccounts":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestinationServiceAccount"},"description":"DestinationServiceAccounts holds information about the service accounts to be impersonated for the application sync operation for each destination."},"sourceIntegrity":{"$ref":"#/components/schemas/appprojectsSourceIntegrity"}},"title":"AppProjectSpec is the specification of an AppProject"},"appprojectsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"appprojectsProjectRole":{"type":"object","properties":{"name":{"type":"string","title":"Name is a name for this role"},"description":{"type":"string","title":"Description is a description of the role"},"policies":{"type":"array","items":{"type":"string"},"title":"Policies Stores a list of casbin formatted strings that define access policies for the role in the project"},"jwtTokens":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"},"title":"JWTTokens are a list of generated JWT tokens bound to this role"},"groups":{"type":"array","items":{"type":"string"},"title":"Groups are a list of OIDC group claims bound to this role"}},"title":"ProjectRole represents a role that has access to a project"},"appprojectsJWTToken":{"type":"object","properties":{"iat":{"type":"string","format":"int64"},"exp":{"type":"string","format":"int64"},"id":{"type":"string"}},"title":"JWTToken holds the issuedAt and expiresAt values of a token"},"appprojectsClusterResourceRestrictionItem":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string","description":"Name is the name of the restricted resource. Glob patterns using Go's filepath.Match syntax are supported.\nUnlike the group and kind fields, if no name is specified, all resources of the specified group/kind are matched."}},"title":"ClusterResourceRestrictionItem is a cluster resource that is restricted by the project's whitelist or blacklist"},"v1GroupKind":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"}},"description":"+protobuf.options.(gogoproto.goproto_stringer)=false","title":"GroupKind specifies a Group and a Kind, but does not force a version.  This is useful for identifying\nconcepts during lookup stages without having partially valid types"},"appprojectsOrphanedResourcesMonitorSettings":{"type":"object","properties":{"warn":{"type":"boolean","title":"Warn indicates if warning condition should be created for apps which have orphaned resources"},"ignore":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsOrphanedResourceKey"},"title":"Ignore contains a list of resources that are to be excluded from orphaned resources monitoring"}},"title":"OrphanedResourcesMonitorSettings holds settings of orphaned resources monitoring"},"appprojectsOrphanedResourceKey":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"}},"title":"OrphanedResourceKey is a reference to a resource to be ignored from"},"appprojectsSyncWindow":{"type":"object","properties":{"kind":{"type":"string","title":"Kind defines if the window allows or blocks syncs"},"schedule":{"type":"string","title":"Schedule is the time the window will begin, specified in cron format"},"duration":{"type":"string","title":"Duration is the amount of time the sync window will be open"},"applications":{"type":"array","items":{"type":"string"},"title":"Applications contains a list of applications that the window will apply to"},"namespaces":{"type":"array","items":{"type":"string"},"title":"Namespaces contains a list of namespaces that the window will apply to"},"clusters":{"type":"array","items":{"type":"string"},"title":"Clusters contains a list of clusters that the window will apply to"},"manualSync":{"type":"boolean","title":"ManualSync enables manual syncs when they would otherwise be blocked"},"timeZone":{"type":"string","title":"TimeZone of the sync that will be applied to the schedule"},"project":{"type":"string","title":"Project this sync window belongs to\nthis will be deprecated in future"}},"title":"SyncWindow contains the kind, time, duration and attributes that are used to assign the syncWindows to apps"},"appprojectsSignatureKey":{"type":"object","properties":{"keyID":{"type":"string","title":"The ID of the key in hexadecimal notation"}},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKey is the specification of a key required to verify commit signatures with"},"appprojectsApplicationDestinationServiceAccount":{"type":"object","properties":{"server":{"type":"string","description":"Server specifies the URL of the target cluster's Kubernetes control plane API."},"namespace":{"type":"string","description":"Namespace specifies the target namespace for the application's resources."},"defaultServiceAccount":{"type":"string","title":"DefaultServiceAccount to be used for impersonation during the sync operation"}},"description":"ApplicationDestinationServiceAccount holds information about the service account to be impersonated for the application sync operation."},"appprojectsSourceIntegrity":{"type":"object","properties":{"git":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGit"}}},"appprojectsSourceIntegrityGit":{"type":"object","properties":{"policies":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicy"}}}},"appprojectsSourceIntegrityGitPolicy":{"type":"object","properties":{"repos":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyRepo"},"title":"List of repository criteria restricting repositories the policy will apply to"},"gpg":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyGPG"}}},"appprojectsSourceIntegrityGitPolicyRepo":{"type":"object","properties":{"url":{"type":"string","description":"URL specifier, glob."}}},"appprojectsSourceIntegrityGitPolicyGPG":{"type":"object","properties":{"mode":{"type":"string"},"keys":{"type":"array","items":{"type":"string"},"description":"List of key IDs to trust. The keys need to be in the repository server keyring."}},"description":"SourceIntegrityGitPolicyGPG verifies that the commit(s) are both correctly signed by a key in the repo-server keyring,\nand that they are signed by one of the key listed in Keys.\n\nThis policy can be deactivated through the ARGOCD_GPG_ENABLED environment variable.\n\nNote the listing of problematic commits/signatures reported when \"strict\" mode validation fails may not be complete.\nThis means that a user that has addressed all problems reported by source integrity check can run into\nfurther problematic signatures on a subsequent attempt. That happens namely when history contains seal commits signed\nwith gpg keys that are in the keyring, but not listed in Keys."},"appprojectsAppProjectStatus":{"type":"object","properties":{"jwtTokensByRole":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/appprojectsJWTTokens"},"title":"JWTTokensByRole contains a list of JWT tokens issued for a given role"}},"title":"AppProjectStatus contains status information for AppProject CRs"},"appprojectsJWTTokens":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"}}},"title":"JWTTokens represents a list of JWT tokens"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## POST /api/v2/agents/{agentIdentifier}/argoprojects

> Create creates an ArgoCD AppProject CRD in the cluster and auto-creates a Harness mapping if one does not exist. If a mapping already exists it is reused.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v2/agents/{agentIdentifier}/argoprojects":{"post":{"description":"Create creates an ArgoCD AppProject CRD in the cluster and auto-creates a Harness mapping if one does not exist. If a mapping already exists it is reused.","operationId":"AgentArgoProjectService_Create","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1ArgoProject"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"mapToHarnessProject.projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"mapToHarnessProject.orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"mapToHarnessProject.autoCreateServiceEnv","description":"Enable automated creation of service,environment and cluster-env link. Defaults to false.","in":"query","required":false,"schema":{"type":"boolean"}}],"requestBody":{"$ref":"#/components/requestBodies/projectsProjectCreateRequest"},"tags":["ArgoProjects"]}}},"components":{"schemas":{"v1ArgoProject":{"type":"object","properties":{"id":{"type":"string"},"accountIdentifier":{"type":"string","description":"Account Identifier for the ArgoProject."},"projectIdentifier":{"type":"string","description":"Project Identifier for the ArgoProject. (Depends on mapping)"},"orgIdentifier":{"type":"string","description":"Organization Identifier for the ArgoProject. (Depends on mapping)"},"name":{"type":"string"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"agentIdentifier":{"type":"string","description":"Agent identifier for ArgoProject. This will be prefixed with scope."},"appProject":{"$ref":"#/components/schemas/appprojectsAppProject"}},"description":"AppProject resource with harness metadata and additional fields."},"appprojectsAppProject":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/appprojectsAppProjectSpec"},"status":{"$ref":"#/components/schemas/appprojectsAppProjectStatus"}},"title":"AppProject provides a logical grouping of applications, providing controls for:\n* where the apps may deploy to (cluster whitelist)\n* what may be deployed (repository whitelist, resource whitelist/blacklist)\n* who can access these applications (roles, OIDC group claims bindings)\n* and what they can do (RBAC policies)\n* automation access to these roles (JWT tokens)\n+genclient\n+genclient:noStatus\n+k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object\n+kubebuilder:resource:path=appprojects,shortName=appproj;appprojs"},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"appprojectsAppProjectSpec":{"type":"object","properties":{"sourceRepos":{"type":"array","items":{"type":"string"},"title":"SourceRepos contains list of repository URLs which can be used for deployment"},"destinations":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestination"},"title":"Destinations contains list of destinations available for deployment"},"description":{"type":"string","title":"Description contains optional project description"},"roles":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsProjectRole"},"title":"Roles are user defined RBAC roles associated with this project"},"clusterResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceWhitelist contains list of whitelisted cluster level resources"},"namespaceResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceBlacklist contains list of blacklisted namespace level resources"},"orphanedResources":{"$ref":"#/components/schemas/appprojectsOrphanedResourcesMonitorSettings"},"syncWindows":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSyncWindow"},"title":"SyncWindows controls when syncs can be run for apps in this project"},"namespaceResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceWhitelist contains list of whitelisted namespace level resources"},"signatureKeys":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSignatureKey"},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKeys contains a list of PGP key IDs that commits in Git must be signed with in order to be allowed for sync"},"clusterResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceBlacklist contains list of blacklisted cluster level resources"},"sourceNamespaces":{"type":"array","items":{"type":"string"},"title":"SourceNamespaces defines the namespaces application resources are allowed to be created in"},"permitOnlyProjectScopedClusters":{"type":"boolean","title":"PermitOnlyProjectScopedClusters determines whether destinations can only reference clusters which are project-scoped"},"destinationServiceAccounts":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestinationServiceAccount"},"description":"DestinationServiceAccounts holds information about the service accounts to be impersonated for the application sync operation for each destination."},"sourceIntegrity":{"$ref":"#/components/schemas/appprojectsSourceIntegrity"}},"title":"AppProjectSpec is the specification of an AppProject"},"appprojectsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"appprojectsProjectRole":{"type":"object","properties":{"name":{"type":"string","title":"Name is a name for this role"},"description":{"type":"string","title":"Description is a description of the role"},"policies":{"type":"array","items":{"type":"string"},"title":"Policies Stores a list of casbin formatted strings that define access policies for the role in the project"},"jwtTokens":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"},"title":"JWTTokens are a list of generated JWT tokens bound to this role"},"groups":{"type":"array","items":{"type":"string"},"title":"Groups are a list of OIDC group claims bound to this role"}},"title":"ProjectRole represents a role that has access to a project"},"appprojectsJWTToken":{"type":"object","properties":{"iat":{"type":"string","format":"int64"},"exp":{"type":"string","format":"int64"},"id":{"type":"string"}},"title":"JWTToken holds the issuedAt and expiresAt values of a token"},"appprojectsClusterResourceRestrictionItem":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string","description":"Name is the name of the restricted resource. Glob patterns using Go's filepath.Match syntax are supported.\nUnlike the group and kind fields, if no name is specified, all resources of the specified group/kind are matched."}},"title":"ClusterResourceRestrictionItem is a cluster resource that is restricted by the project's whitelist or blacklist"},"v1GroupKind":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"}},"description":"+protobuf.options.(gogoproto.goproto_stringer)=false","title":"GroupKind specifies a Group and a Kind, but does not force a version.  This is useful for identifying\nconcepts during lookup stages without having partially valid types"},"appprojectsOrphanedResourcesMonitorSettings":{"type":"object","properties":{"warn":{"type":"boolean","title":"Warn indicates if warning condition should be created for apps which have orphaned resources"},"ignore":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsOrphanedResourceKey"},"title":"Ignore contains a list of resources that are to be excluded from orphaned resources monitoring"}},"title":"OrphanedResourcesMonitorSettings holds settings of orphaned resources monitoring"},"appprojectsOrphanedResourceKey":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"}},"title":"OrphanedResourceKey is a reference to a resource to be ignored from"},"appprojectsSyncWindow":{"type":"object","properties":{"kind":{"type":"string","title":"Kind defines if the window allows or blocks syncs"},"schedule":{"type":"string","title":"Schedule is the time the window will begin, specified in cron format"},"duration":{"type":"string","title":"Duration is the amount of time the sync window will be open"},"applications":{"type":"array","items":{"type":"string"},"title":"Applications contains a list of applications that the window will apply to"},"namespaces":{"type":"array","items":{"type":"string"},"title":"Namespaces contains a list of namespaces that the window will apply to"},"clusters":{"type":"array","items":{"type":"string"},"title":"Clusters contains a list of clusters that the window will apply to"},"manualSync":{"type":"boolean","title":"ManualSync enables manual syncs when they would otherwise be blocked"},"timeZone":{"type":"string","title":"TimeZone of the sync that will be applied to the schedule"},"project":{"type":"string","title":"Project this sync window belongs to\nthis will be deprecated in future"}},"title":"SyncWindow contains the kind, time, duration and attributes that are used to assign the syncWindows to apps"},"appprojectsSignatureKey":{"type":"object","properties":{"keyID":{"type":"string","title":"The ID of the key in hexadecimal notation"}},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKey is the specification of a key required to verify commit signatures with"},"appprojectsApplicationDestinationServiceAccount":{"type":"object","properties":{"server":{"type":"string","description":"Server specifies the URL of the target cluster's Kubernetes control plane API."},"namespace":{"type":"string","description":"Namespace specifies the target namespace for the application's resources."},"defaultServiceAccount":{"type":"string","title":"DefaultServiceAccount to be used for impersonation during the sync operation"}},"description":"ApplicationDestinationServiceAccount holds information about the service account to be impersonated for the application sync operation."},"appprojectsSourceIntegrity":{"type":"object","properties":{"git":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGit"}}},"appprojectsSourceIntegrityGit":{"type":"object","properties":{"policies":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicy"}}}},"appprojectsSourceIntegrityGitPolicy":{"type":"object","properties":{"repos":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyRepo"},"title":"List of repository criteria restricting repositories the policy will apply to"},"gpg":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyGPG"}}},"appprojectsSourceIntegrityGitPolicyRepo":{"type":"object","properties":{"url":{"type":"string","description":"URL specifier, glob."}}},"appprojectsSourceIntegrityGitPolicyGPG":{"type":"object","properties":{"mode":{"type":"string"},"keys":{"type":"array","items":{"type":"string"},"description":"List of key IDs to trust. The keys need to be in the repository server keyring."}},"description":"SourceIntegrityGitPolicyGPG verifies that the commit(s) are both correctly signed by a key in the repo-server keyring,\nand that they are signed by one of the key listed in Keys.\n\nThis policy can be deactivated through the ARGOCD_GPG_ENABLED environment variable.\n\nNote the listing of problematic commits/signatures reported when \"strict\" mode validation fails may not be complete.\nThis means that a user that has addressed all problems reported by source integrity check can run into\nfurther problematic signatures on a subsequent attempt. That happens namely when history contains seal commits signed\nwith gpg keys that are in the keyring, but not listed in Keys."},"appprojectsAppProjectStatus":{"type":"object","properties":{"jwtTokensByRole":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/appprojectsJWTTokens"},"title":"JWTTokensByRole contains a list of JWT tokens issued for a given role"}},"title":"AppProjectStatus contains status information for AppProject CRs"},"appprojectsJWTTokens":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"}}},"title":"JWTTokens represents a list of JWT tokens"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"},"projectsProjectCreateRequest":{"type":"object","properties":{"project":{"$ref":"#/components/schemas/appprojectsAppProject"},"upsert":{"type":"boolean"}},"description":"ProjectCreateRequest defines project creation parameters."}},"requestBodies":{"projectsProjectCreateRequest":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/projectsProjectCreateRequest"}}},"required":true}}}}
```

## GET /api/v2/agents/{agentIdentifier}/argoprojects/{query.name}

> Get returns an ArgoCD AppProject by name. Must be mapped to a Harness project.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v2/agents/{agentIdentifier}/argoprojects/{query.name}":{"get":{"description":"Get returns an ArgoCD AppProject by name. Must be mapped to a Harness project.","operationId":"AgentArgoProjectService_Get","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1ArgoProject"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"query.name","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"pageSize","in":"query","required":false,"schema":{"type":"integer","format":"int32"}},{"name":"pageIndex","in":"query","required":false,"schema":{"type":"integer","format":"int32"}}],"tags":["ArgoProjects"]}}},"components":{"schemas":{"v1ArgoProject":{"type":"object","properties":{"id":{"type":"string"},"accountIdentifier":{"type":"string","description":"Account Identifier for the ArgoProject."},"projectIdentifier":{"type":"string","description":"Project Identifier for the ArgoProject. (Depends on mapping)"},"orgIdentifier":{"type":"string","description":"Organization Identifier for the ArgoProject. (Depends on mapping)"},"name":{"type":"string"},"createdAt":{"type":"string","format":"date-time"},"lastModifiedAt":{"type":"string","format":"date-time"},"agentIdentifier":{"type":"string","description":"Agent identifier for ArgoProject. This will be prefixed with scope."},"appProject":{"$ref":"#/components/schemas/appprojectsAppProject"}},"description":"AppProject resource with harness metadata and additional fields."},"appprojectsAppProject":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/appprojectsAppProjectSpec"},"status":{"$ref":"#/components/schemas/appprojectsAppProjectStatus"}},"title":"AppProject provides a logical grouping of applications, providing controls for:\n* where the apps may deploy to (cluster whitelist)\n* what may be deployed (repository whitelist, resource whitelist/blacklist)\n* who can access these applications (roles, OIDC group claims bindings)\n* and what they can do (RBAC policies)\n* automation access to these roles (JWT tokens)\n+genclient\n+genclient:noStatus\n+k8s:deepcopy-gen:interfaces=k8s.io/apimachinery/pkg/runtime.Object\n+kubebuilder:resource:path=appprojects,shortName=appproj;appprojs"},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"appprojectsAppProjectSpec":{"type":"object","properties":{"sourceRepos":{"type":"array","items":{"type":"string"},"title":"SourceRepos contains list of repository URLs which can be used for deployment"},"destinations":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestination"},"title":"Destinations contains list of destinations available for deployment"},"description":{"type":"string","title":"Description contains optional project description"},"roles":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsProjectRole"},"title":"Roles are user defined RBAC roles associated with this project"},"clusterResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceWhitelist contains list of whitelisted cluster level resources"},"namespaceResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceBlacklist contains list of blacklisted namespace level resources"},"orphanedResources":{"$ref":"#/components/schemas/appprojectsOrphanedResourcesMonitorSettings"},"syncWindows":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSyncWindow"},"title":"SyncWindows controls when syncs can be run for apps in this project"},"namespaceResourceWhitelist":{"type":"array","items":{"$ref":"#/components/schemas/v1GroupKind"},"title":"NamespaceResourceWhitelist contains list of whitelisted namespace level resources"},"signatureKeys":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSignatureKey"},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKeys contains a list of PGP key IDs that commits in Git must be signed with in order to be allowed for sync"},"clusterResourceBlacklist":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsClusterResourceRestrictionItem"},"title":"ClusterResourceBlacklist contains list of blacklisted cluster level resources"},"sourceNamespaces":{"type":"array","items":{"type":"string"},"title":"SourceNamespaces defines the namespaces application resources are allowed to be created in"},"permitOnlyProjectScopedClusters":{"type":"boolean","title":"PermitOnlyProjectScopedClusters determines whether destinations can only reference clusters which are project-scoped"},"destinationServiceAccounts":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsApplicationDestinationServiceAccount"},"description":"DestinationServiceAccounts holds information about the service accounts to be impersonated for the application sync operation for each destination."},"sourceIntegrity":{"$ref":"#/components/schemas/appprojectsSourceIntegrity"}},"title":"AppProjectSpec is the specification of an AppProject"},"appprojectsApplicationDestination":{"type":"object","properties":{"server":{"type":"string","title":"Server specifies the URL of the target cluster and must be set to the Kubernetes control plane API"},"namespace":{"type":"string","title":"Namespace specifies the target namespace for the application's resources.\nThe namespace will only be set for namespace-scoped resources that have not set a value for .metadata.namespace"},"name":{"type":"string","title":"Name is an alternate way of specifying the target cluster by its symbolic name"}},"title":"ApplicationDestination holds information about the application's destination"},"appprojectsProjectRole":{"type":"object","properties":{"name":{"type":"string","title":"Name is a name for this role"},"description":{"type":"string","title":"Description is a description of the role"},"policies":{"type":"array","items":{"type":"string"},"title":"Policies Stores a list of casbin formatted strings that define access policies for the role in the project"},"jwtTokens":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"},"title":"JWTTokens are a list of generated JWT tokens bound to this role"},"groups":{"type":"array","items":{"type":"string"},"title":"Groups are a list of OIDC group claims bound to this role"}},"title":"ProjectRole represents a role that has access to a project"},"appprojectsJWTToken":{"type":"object","properties":{"iat":{"type":"string","format":"int64"},"exp":{"type":"string","format":"int64"},"id":{"type":"string"}},"title":"JWTToken holds the issuedAt and expiresAt values of a token"},"appprojectsClusterResourceRestrictionItem":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string","description":"Name is the name of the restricted resource. Glob patterns using Go's filepath.Match syntax are supported.\nUnlike the group and kind fields, if no name is specified, all resources of the specified group/kind are matched."}},"title":"ClusterResourceRestrictionItem is a cluster resource that is restricted by the project's whitelist or blacklist"},"v1GroupKind":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"}},"description":"+protobuf.options.(gogoproto.goproto_stringer)=false","title":"GroupKind specifies a Group and a Kind, but does not force a version.  This is useful for identifying\nconcepts during lookup stages without having partially valid types"},"appprojectsOrphanedResourcesMonitorSettings":{"type":"object","properties":{"warn":{"type":"boolean","title":"Warn indicates if warning condition should be created for apps which have orphaned resources"},"ignore":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsOrphanedResourceKey"},"title":"Ignore contains a list of resources that are to be excluded from orphaned resources monitoring"}},"title":"OrphanedResourcesMonitorSettings holds settings of orphaned resources monitoring"},"appprojectsOrphanedResourceKey":{"type":"object","properties":{"group":{"type":"string"},"kind":{"type":"string"},"name":{"type":"string"}},"title":"OrphanedResourceKey is a reference to a resource to be ignored from"},"appprojectsSyncWindow":{"type":"object","properties":{"kind":{"type":"string","title":"Kind defines if the window allows or blocks syncs"},"schedule":{"type":"string","title":"Schedule is the time the window will begin, specified in cron format"},"duration":{"type":"string","title":"Duration is the amount of time the sync window will be open"},"applications":{"type":"array","items":{"type":"string"},"title":"Applications contains a list of applications that the window will apply to"},"namespaces":{"type":"array","items":{"type":"string"},"title":"Namespaces contains a list of namespaces that the window will apply to"},"clusters":{"type":"array","items":{"type":"string"},"title":"Clusters contains a list of clusters that the window will apply to"},"manualSync":{"type":"boolean","title":"ManualSync enables manual syncs when they would otherwise be blocked"},"timeZone":{"type":"string","title":"TimeZone of the sync that will be applied to the schedule"},"project":{"type":"string","title":"Project this sync window belongs to\nthis will be deprecated in future"}},"title":"SyncWindow contains the kind, time, duration and attributes that are used to assign the syncWindows to apps"},"appprojectsSignatureKey":{"type":"object","properties":{"keyID":{"type":"string","title":"The ID of the key in hexadecimal notation"}},"description":"Deprecated: Use SourceIntegrity instead. SignatureKeys will be removed with the next major version.","title":"SignatureKey is the specification of a key required to verify commit signatures with"},"appprojectsApplicationDestinationServiceAccount":{"type":"object","properties":{"server":{"type":"string","description":"Server specifies the URL of the target cluster's Kubernetes control plane API."},"namespace":{"type":"string","description":"Namespace specifies the target namespace for the application's resources."},"defaultServiceAccount":{"type":"string","title":"DefaultServiceAccount to be used for impersonation during the sync operation"}},"description":"ApplicationDestinationServiceAccount holds information about the service account to be impersonated for the application sync operation."},"appprojectsSourceIntegrity":{"type":"object","properties":{"git":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGit"}}},"appprojectsSourceIntegrityGit":{"type":"object","properties":{"policies":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicy"}}}},"appprojectsSourceIntegrityGitPolicy":{"type":"object","properties":{"repos":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyRepo"},"title":"List of repository criteria restricting repositories the policy will apply to"},"gpg":{"$ref":"#/components/schemas/appprojectsSourceIntegrityGitPolicyGPG"}}},"appprojectsSourceIntegrityGitPolicyRepo":{"type":"object","properties":{"url":{"type":"string","description":"URL specifier, glob."}}},"appprojectsSourceIntegrityGitPolicyGPG":{"type":"object","properties":{"mode":{"type":"string"},"keys":{"type":"array","items":{"type":"string"},"description":"List of key IDs to trust. The keys need to be in the repository server keyring."}},"description":"SourceIntegrityGitPolicyGPG verifies that the commit(s) are both correctly signed by a key in the repo-server keyring,\nand that they are signed by one of the key listed in Keys.\n\nThis policy can be deactivated through the ARGOCD_GPG_ENABLED environment variable.\n\nNote the listing of problematic commits/signatures reported when \"strict\" mode validation fails may not be complete.\nThis means that a user that has addressed all problems reported by source integrity check can run into\nfurther problematic signatures on a subsequent attempt. That happens namely when history contains seal commits signed\nwith gpg keys that are in the keyring, but not listed in Keys."},"appprojectsAppProjectStatus":{"type":"object","properties":{"jwtTokensByRole":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/appprojectsJWTTokens"},"title":"JWTTokensByRole contains a list of JWT tokens issued for a given role"}},"title":"AppProjectStatus contains status information for AppProject CRs"},"appprojectsJWTTokens":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/appprojectsJWTToken"}}},"title":"JWTTokens represents a list of JWT tokens"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## DELETE /api/v2/agents/{agentIdentifier}/argoprojects/{query.name}

> Delete deletes an ArgoCD AppProject from the cluster. Must be mapped. Does not remove the Harness mapping.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v2/agents/{agentIdentifier}/argoprojects/{query.name}":{"delete":{"description":"Delete deletes an ArgoCD AppProject from the cluster. Must be mapped. Does not remove the Harness mapping.","operationId":"AgentArgoProjectService_Delete","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/projectsEmptyResponse"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"query.name","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"pageSize","in":"query","required":false,"schema":{"type":"integer","format":"int32"}},{"name":"pageIndex","in":"query","required":false,"schema":{"type":"integer","format":"int32"}}],"tags":["ArgoProjects"]}}},"components":{"schemas":{"projectsEmptyResponse":{"type":"object"},"gatewayruntimeError":{"type":"object","properties":{"error":{"type":"string"},"code":{"type":"integer","format":"int32"},"message":{"type":"string"},"details":{"type":"array","items":{"$ref":"#/components/schemas/protobufAny"}}}},"protobufAny":{"type":"object","properties":{"type_url":{"type":"string","description":"A URL/resource name that uniquely identifies the type of the serialized\nprotocol buffer message. This string must contain at least\none \"/\" character. The last segment of the URL's path must represent\nthe fully qualified name of the type (as in\n`path/google.protobuf.Duration`). The name should be in a canonical form\n(e.g., leading \".\" is not accepted).\n\nIn practice, teams usually precompile into the binary all types that they\nexpect it to use in the context of Any. However, for URLs which use the\nscheme `http`, `https`, or no scheme, one can optionally set up a type\nserver that maps type URLs to message definitions as follows:\n\n* If no scheme is provided, `https` is assumed.\n* An HTTP GET on the URL must yield a [google.protobuf.Type][]\n  value in binary format, or produce an error.\n* Applications are allowed to cache lookup results based on the\n  URL, or have them precompiled into a binary to avoid any\n  lookup. Therefore, binary compatibility needs to be preserved\n  on changes to types. (Use versioned type names to manage\n  breaking changes.)\n\nNote: this functionality is not currently available in the official\nprotobuf release, and it is not used for type URLs beginning with\ntype.googleapis.com.\n\nSchemes other than `http`, `https` (or the empty scheme) might be\nused with implementation specific semantics."},"value":{"type":"string","format":"byte","description":"Must be a valid serialized protocol buffer of the above specified type."}},"description":"`Any` contains an arbitrary serialized protocol buffer message along with a\nURL that describes the type of the serialized message.\n\nProtobuf library provides support to pack/unpack Any values in the form\nof utility functions or additional generated methods of the Any type.\n\nExample 1: Pack and unpack a message in C++.\n\n    Foo foo = ...;\n    Any any;\n    any.PackFrom(foo);\n    ...\n    if (any.UnpackTo(&foo)) {\n      ...\n    }\n\nExample 2: Pack and unpack a message in Java.\n\n    Foo foo = ...;\n    Any any = Any.pack(foo);\n    ...\n    if (any.is(Foo.class)) {\n      foo = any.unpack(Foo.class);\n    }\n\n Example 3: Pack and unpack a message in Python.\n\n    foo = Foo(...)\n    any = Any()\n    any.Pack(foo)\n    ...\n    if any.Is(Foo.DESCRIPTOR):\n      any.Unpack(foo)\n      ...\n\n Example 4: Pack and unpack a message in Go\n\n     foo := &pb.Foo{...}\n     any, err := anypb.New(foo)\n     if err != nil {\n       ...\n     }\n     ...\n     foo := &pb.Foo{}\n     if err := any.UnmarshalTo(foo); err != nil {\n       ...\n     }\n\nThe pack methods provided by protobuf library will by default use\n'type.googleapis.com/full.type.name' as the type URL and the unpack\nmethods only use the fully qualified type name after the last '/'\nin the type URL, for example \"foo.bar.com/x/y.z\" will yield type\nname \"y.z\".\n\n\nJSON\n====\nThe JSON representation of an `Any` value uses the regular\nrepresentation of the deserialized, embedded message, with an\nadditional field `@type` which contains the type URL. Example:\n\n    package google.profile;\n    message Person {\n      string first_name = 1;\n      string last_name = 2;\n    }\n\n    {\n      \"@type\": \"type.googleapis.com/google.profile.Person\",\n      \"firstName\": <string>,\n      \"lastName\": <string>\n    }\n\nIf the embedded message type is well-known and has a custom JSON\nrepresentation, that representation will be embedded adding a field\n`value` which holds the custom JSON in addition to the `@type`\nfield. Example (for message [google.protobuf.Duration][]):\n\n    {\n      \"@type\": \"type.googleapis.com/google.protobuf.Duration\",\n      \"value\": \"1.212s\"\n    }"}}}}
```

## GET /api/v2/agents/{agentIdentifier}/argoprojects/{query.name}/events

> ListEvents returns Kubernetes events for a named ArgoCD AppProject. Must be mapped.

```json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v2/agents/{agentIdentifier}/argoprojects/{query.name}/events":{"get":{"description":"ListEvents returns Kubernetes events for a named ArgoCD AppProject. Must be mapped.","operationId":"AgentArgoProjectService_ListEvents","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/applicationsEventList"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"query.name","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"pageSize","in":"query","required":false,"schema":{"type":"integer","format":"int32"}},{"name":"pageIndex","in":"query","required":false,"schema":{"type":"integer","format":"int32"}}],"tags":["ArgoProjects"]}}},"components":{"schemas":{"applicationsEventList":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ListMeta"},"items":{"type":"array","items":{"$ref":"#/components/schemas/applicationsEvent"},"title":"List of events"}},"description":"EventList is a list of events."},"v1ListMeta":{"type":"object","properties":{"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"resourceVersion":{"type":"string","title":"String that identifies the server's internal version of this object that\ncan be used by clients to determine when objects have changed.\nValue must be treated as opaque by clients and passed unmodified back to the server.\nPopulated by the system.\nRead-only.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"continue":{"type":"string","description":"continue may be set if the user set a limit on the number of items returned, and indicates that\nthe server has more data available. The value is opaque and may be used to issue another request\nto the endpoint that served this list to retrieve the next set of available objects. Continuing a\nconsistent list may not be possible if the server configuration has changed or more than a few\nminutes have passed. The resourceVersion field returned when using this continue value will be\nidentical to the value in the first response, unless you have received this token from an error\nmessage."},"remainingItemCount":{"type":"string","format":"int64","title":"remainingItemCount is the number of subsequent items in the list which are not included in this\nlist response. If the list request contained label or field selectors, then the number of\nremaining items is unknown and the field will be left unset and omitted during serialization.\nIf the list is complete (either because it is not chunking or because this is the last chunk),\nthen there are no more remaining items and this field will be left unset and omitted during\nserialization.\nServers older than v1.15 do not set this field.\nThe intended use of the remainingItemCount is *estimating* the size of a collection. Clients\nshould not rely on the remainingItemCount to be set or to be exact.\n+optional"},"shardInfo":{"$ref":"#/components/schemas/v1ShardInfo"}},"description":"ListMeta describes metadata that synthetic resources must have, including lists and\nvarious status objects. A resource may have only one of {ObjectMeta, ListMeta}."},"v1ShardInfo":{"type":"object","properties":{"selector":{"type":"string","title":"selector is the shard selector string from the request, echoed back so clients\ncan verify which shard they received and merge responses from multiple shards.\n+required"}},"description":"ShardInfo describes the shard selector that was applied to produce a list response.\nIts presence on a list response indicates the list is a filtered subset."},"applicationsEvent":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"involvedObject":{"$ref":"#/components/schemas/applicationsObjectReference"},"reason":{"type":"string","title":"This should be a short, machine understand
[...]
